import pandas as pd
import numpy as np
from sklearn.model_selection import train_test_split

def spilt(data, label):
    #First divide into half training and half testing; how many features should go in and allocate them here, for example only 18 features go in
    X1 = np.array(data)
    X1 = X1[:,0:18]
    y1 = np.array(label['class'].tolist())

    X_train, X_test, y_train, y_test = train_test_split(X1, y1, test_size=float(0.5), random_state=0,stratify = y1)

    pd.DataFrame(X_train).to_csv("./result/sample/data_train.csv")
    pd.DataFrame(X_test).to_csv("./result/sample/data_test.csv")
    pd.DataFrame(y_train).to_csv("./result/sample/label_train.csv")
    pd.DataFrame(y_test).to_csv("./result/sample/label_test.csv")
    
    #Train the network with half of the samples, and then this half to train the classifier
    train_data = pd.read_csv("./result/sample/data_train.csv", index_col=0)
    train_label = pd.read_csv("./result/sample/label_train.csv", index_col=0)
    X = np.array(train_data)
    y = np.array(train_label['0'].tolist())

    y_i = np.array(train_label.index)
    data_P = []
    data_N = []
    label_P = []
    label_N = []
    P = []
    N = []
    for i in range(0, y.size):
        if y[i] == 1:
            label_P.append(y_i[i])
            data_P.append(X[i])
            P.append(1)
        else:
            label_N.append(y_i[i])
            data_N.append(X[i])
            N.append(0)

    new_label_P = pd.DataFrame(np.array([P]).T)
    new_data = pd.DataFrame(data_P)
    X = np.array(data_N)
    y = N

    pd.DataFrame(X).to_csv("./result/sample/data_train1.csv")
    #test_data.to_csv("./result/sample/data_test.csv")
    pd.DataFrame(y).to_csv("./result/sample/label_train1.csv")
    #test_label.to_csv("./result/sample/label_test.csv")

if __name__ == '__main__':
    #spilt_num = 0.333333
    data = pd.read_csv("hccdata.csv", index_col=0)
    label = pd.read_csv("hcclabel.csv", index_col=0)

    spilt(data, label)
