import pandas as pd
import numpy as np
from sklearn.model_selection import train_test_split

def spilt(data, label, spilt_num):
    X = np.array(data)
    y = np.array(label['class'].tolist())

    y_i = np.array(label.index)
    data_P = []
    data_N = []
    label_P = []
    label_N = []
    P = []
    N = []
    for i in range(0, y.size):
        if y[i] == 1:
            label_P.append(y_i[i])
            data_P.append(X[i])
            P.append('1')
        else:
            label_N.append(y_i[i])
            data_N.append(X[i])
            N.append('0')

    new_label_P = pd.DataFrame(np.array([P]).T)
    new_data = pd.DataFrame(data_P)
    X = np.array(data_N)
    y = N
    X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=float(spilt_num), random_state=0)

    test_data1 = pd.DataFrame(X_test)
    test_data = pd.concat([test_data1, new_data]).reset_index(drop=True)
    test_label1 = pd.DataFrame(y_test)
    test_label = pd.concat([test_label1, new_label_P]).reset_index(drop=True)

    pd.DataFrame(X_train).to_csv("./result/sample/data_train.csv")
    test_data.to_csv("./result/sample/data_test.csv")
    pd.DataFrame(y_train).to_csv("./result/sample/label_train.csv")
    test_label.to_csv("./result/sample/label_test.csv")

if __name__ == '__main__':
    spilt_num = 0.333333
    data = pd.read_csv("BRCA.csv", index_col=0)
    label = pd.read_csv("BRCA_label.csv", index_col=0)

    spilt(data, label, spilt_num)